********************************************************************************
* Program: 0_Master.do
* Author: Alexis Rivera-Ballesteros
* Created: 27 Nov 2023
* Modified: 		
* Purpose: Replication of "Are the Poorest Catching Up?" by
*		   James Cust, Paul Collier and Alexis Rivera-Ballesteros (2023).
********************************************************************************

	clear all
	set more off
	set varabbrev on

	set sortseed 3589

	
* 1. Set up your user specific root directory to Replication Materials folder

		global dir "./"
		sysdir set PLUS "./ado"
		
* 3. Route file paths

		// Code
		global code "${dir}Code/"
		
		// Base Data
		global base "${dir}Data/base/"
		
		// Data
		global clean "${dir}Data/clean/"
		
		// Output
		global output "${dir}Output/"

* 4. Run replication files

	do "${code}1_Package_Setup.do"
	do "${code}2_Data_Construction.do"
	do "${code}3_Tables_Figures.do"

cap log close main
cap log off main
	
